/*
** main.c for Wave Repeat plugin / The Gmurf Team
**
** This could be considered the simplest filter to be done...
** sam-lo_p@epita.fr
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include<unistd.h>
#include<signal.h>
#include<sys/stat.h>
#include<sys/types.h>
#include"Filter_Data.h"

#define SRC_FILE   1
#define DST_FILE   2
#define NFO_FILE   3
#define NB_REPEATS 4
#define TIME       5
#define BEGIN      6
#define FATHER_PID 7
#define NB_ARGS    8

// system function to have the file size
off_t give_file_size(file)
     int file;
{
  struct stat	buf;

  if (fstat(file, &buf) == -1)
    {
      return (0);
    }
  return (buf.st_size);
}

// main program
int main(int argc, char* argv[])
{
  int           srcfd, dstfd;
  int           result;
  int           i;
  size_t        fsize;
  char          buf[CPY_BUF_SIZE];
  t_filterdata* filterdata;

  if (argc != NB_ARGS)
    {
      printf("Args should be %d, but they are %d.\n",NB_ARGS-1, argc-1);
      return(-1);
    }
  
  // initialisation
  filterdata = filterdata_new(argv[NFO_FILE]);
  if (filterdata == NULL)
    {
      printf("Filterdata file open failed.");
      return(-2);
    }

  srcfd = open(argv[SRC_FILE], O_RDONLY);
  if (srcfd < 0)
    {
      printf("Source '%s' open failed.\n",argv[SRC_FILE]);
      return(-3);
    }
  
  dstfd = open(argv[DST_FILE], O_WRONLY | O_TRUNC | O_CREAT, 0644);

  if (dstfd < 0)
    {
      printf("Destination '%s' open failed.\n",argv[DST_FILE]);
      close(srcfd);
      return(-4);
    }

  fsize = give_file_size(srcfd);
  i     = 1;

  //copy processing
  while (i <= atoi(argv[NB_REPEATS]))
    {
      lseek(srcfd, 0, SEEK_SET);

      while ((result = read(srcfd, buf, CPY_BUF_SIZE))> 0)
	write(dstfd, buf, result);

      lseek(dstfd, atoi(argv[TIME]) - fsize*atoi(argv[BEGIN]), SEEK_END);
      i++;
    }

  // end
  filterdata->filter_data->temp_size = give_file_size(dstfd);
  close(srcfd);
  close(dstfd);
  // filterdata_write(filterdata);
  filterdata_destroy(filterdata);
  kill(atoi(argv[FATHER_PID]), 15);
  return(0);
}
